#!/usr/local/bin/perl

$VERSION = "0.01";

# 1998/05/15	0.01	VK쐬

require "libb64.pl";

$myname = $0;
$myname =~ s%.*\/%%og;

$DEBUG = 0;
while ($ARGV[0] =~ /^\-/o)
{
    $switch = shift;

    if (($switch eq "-d") || ($switch eq "--debug"))
    {
	$DEBUG = 1;
    }
}

if ($#ARGV != 3)
{
    print STDERR "Usage: $myname passwdfile label username passwd\n";
    exit(1);
}

$passwdfile = shift;
$label = shift;
$username = shift;
$passwd = shift;

%passwd = ();

if (-e $passwdfile)
{
    local($label, $passwd);

    open(PASSWDFILE, "$passwdfile") || &die("$passwdfile: $!");

    while(<PASSWDFILE>)
    {
	s/[\015\012]//og;
	($label, $passwd) = split(":");
	$passwd{$label} = $passwd;
	print "\$passwd{$label} = $passwd\n" if ($DEBUG);
    }

    close(PASSWDFILE);
}

$passwd{$label} = &base64encode($username.":".$passwd);

open(PASSWDFILE, ">$passwdfile") || &die("$passwdfile: $!");

while(($label, $passwd) = each(%passwd))
{
    print PASSWDFILE "$label:$passwd\n";
}

close(PASSWDFILE);

1;
