#!/usr/local/bin/perl

$HINA_VERSION = "2.110";

# 1999/08/26	2.110	libhina.pl 0.52б
# 1999/08/25	2.109	libhina.pl 0.51
# 1999/08/21	2.108	libhina.pl 0.50
#			Perl4ưʤʤäƤΤǽ
# 1999/08/17    2.107   Ի%tatitleִ褦ˤ
# 1999/08/07	2.106	URLquery string¸ߤν
#			ԴäΤǽ
# 1999/07/02	2.105	libhina.pl 0.49
# 1999/07/01	2.104	libhina.pl 0.48
# 1999/06/24	2.103	URLquery string¸ߤȤˡquery string
#			ղäʤ褦ˤ
# 1999/06/21	2.102	libhina.pl 0.47
#			libtime.pl, libhina.plΥСåɲ
# 1999/06/19	2.101	DI˼Ԥ뤳ȤԶ
# 1999/06/17	2.100	꡼ΤСֹѹ
# 1999/06/14	2.011	$HINA_AUTHOR_NAMEƤʤäΤǽ
# 1999/05/14	2.010	Сֹhina.pl˹碌
# 1999/04/23	2.009	%7E򤹤٤~ִƽ褦ˤ
# 1999/04/24	2.008	%Sִ˼ԤԶ
# 1999/04/23	2.007	%7E~Ʊ뤬ԴäΤǽ
# 1999/04/22	2.006	ѥ᡼θ
# 1999/04/16	2.002	libhina.pl 0.37
# 1999/04/14	2.001	libhina.pl 0.36
# 1999/04/14	2.000	꡼ΤСֹѹ
# 1999/03/19	1.9992	hina.pl 1.9992Ȥ˺
#			jcode.plȤ褦ˤ

eval "exec $PERL -S $0 $*"
    if $running_under_some_shell;
			# this emulates #! processing on NIH machines.
			# (remove #! line above if indigestible)

eval '$'.$1.'$2;' while $ARGV[0] =~ /^([A-Za-z_]+=)(.*)/ && shift;
			# process any FOO=bar switches


require "hina.ph";
require "libtime.pl";
if ($libtime'VERSION < 0.05)
{
    die "libtime.pl 0.05 or later is required.";
}
require "libhina.pl";
if ($libhina'VERSION < 0.52)
{
    die "libhina.pl 0.52 or later is required.";
}
eval { require "jcode.pl"; };
$HAVE_JCODE_PL = ($@ eq "");

$, = ' ';		# set output field separator

chdir $DIR || die "Can't chdir $DIR\n";

$FORCE = 0;
$DEBUG = 0;

while ($ARGV[0] =~ /^\-/o)
{
    local($switch) = shift;

    $DEBUG = 1 if (($switch eq "-d") || ($switch eq "--debug"));
    $FORCE = 1 if (($switch eq "-f") || ($switch eq "--force"));
    $LOGFILE = shift if (($switch eq "-l") || ($switch eq "--logfile"));
}

if (! $FORCE)
{
    eval {
	symlink("hina.pl", "hina.lock")
	    || die("hina$HINA_VERSION: lock-file exists.\n");
    };

    if ($@ ne "")
    {
	if ($@ =~ /Unimplemented/io)
	{
	    if (-f "hina.lock")
	    {
		die("hina$HINA_VERSION: lock-file exists.\n");
	    }
	    
	    open(LOCKFILE, ">hina.lock");
	    close(LOCKFILE);
	}
	else
	{
	    die("$@");
	}
    }
}

if ($LOGFILE ne "")
{
    open(LOGFILE, "> $LOGFILE") || die("$LOGFILE: $!");
}

$PARENT = $$;

$SIG{'HUP'} = 'DoTerminateParent';
$SIG{'INT'} = 'DoKillParent';
$SIG{'TERM'} = 'DoKillChild';

$AGENT	= "Asahina-Antenna/".$HINA_VERSION;
$AGENT .= " (";
$AGENT .= "libhina.pl/".$libhina'VERSION;
$AGENT .= " ; ";
$AGENT .= "libtime.pl/".$libtime'VERSION; #'
$AGENT .= ")";
$TMPFILE = "/tmp/hina.$$";
$USERDIR = "public_html" if (!defined($USERDIR));
$MAXHOP = 2 if (!defined($MAXHOP));
$UNKNOWN = "" if (!defined($UNKNOWN));
$TIMEOUT = "٤С" if (!defined($TIMEOUT));
$BUSY = "ߤ" if (!defined($BUSY));
$REMOUT = "Ϥʤ" if (!defined($REMOUT));
$INTERR = "ƥʤ褩" if (!defined($INTERR));
$NFOUND = "ɤäää" if (!defined($NFOUND));
$HINA_TIMEFMT = "{%Y/%m/%d %R} (%S)%?" if (!defined($HINA_TIMEFMT));
$DEFAULT_QUERY = "?%m%d%H%M" if (!defined($DEFAULT_QUERY));
$CERNMARK = "*" if (!defined($CERNMARK));
$NOTCERNMARK = "" if (!defined($CERNMARK));
$OLDFORMATONLY = "no" if (! defined($OLDFORMATONLY));

$LIFETIME = 5400 if (! defined($LIFETIME));
$EXPIRE = 21600 if (! defined($EXPIRE));

$libhina{'SYSV'} = $SYSV if (defined($SYSV));
$libhina{'LIFETIME'} = $LIFETIME;
$libhina{'EXPIRE'} = $EXPIRE;
&initlibhina(*libhina);

%PASSWD = ();
&loadauthfile($AUTHFILE, *PASSWD);

%SYMBOL = ();
$MYFILE = "hina.txt";
$OLDDATE = 0;

@DISOURCE = ();

$PROXYSERVER = "";
$PROXYSERVER = $ENV{'http_proxy'} if (defined($ENV{'http_proxy'}));
$PROXYSERVER = $HINA_PROXY if (defined($HINA_PROXY));
$PROXYSERVER =~ s%http://%%o;
$PROXYSERVER =~ s%/$%%o;

$REQUIRED_VERSION = 0;

local($didist) = "/tmp/hina2.$$";

while ($#ARGV >= 0)
{
    local($arg);

    &msg("Arg: $ARGV[0]\n");
    last if ($ARGV[0] !~ /^(\w+)\:\/\//o);
    $arg = shift(@ARGV);
    last if (($arg eq "-f") || ($arg eq "--file"));
    $DISOURCE[$#DISOURCE + 1] =$arg;
    &msg("DIsource: $arg\n");
}

while ($#DISOURCE >= 0)
{
    local($disource) = shift(@DISOURCE);
    {
	&msg("GetDI from $disource\n");
	&hina2($disource, $didist);
	unlink($didist) if (-f $didist);
    }
}

while ($line = <>)
{
    &jcode'convert(*line, "euc"); #'
    undef($HINA_HREF) if (defined($HINA_HREF));
    $HINA_QUERY = $DEFAULT_QUERY;
    
    if ($line =~ /^\#/o)
    {
	next;
    }

    if ($line =~ /^\s*require\s+([\d\.]+)/o)
    {
	$REQUIRED_VERSION = $1;
	if ($REQUIRED_VERSION > $HINA_VERSION)
	{
	    print "hina $REQUIRED_VERSION required.\n";
	    &DoKillParent();
	    exit 1;
	}

	next;
    }

    if ($REQUIRED_VERSION)
    {
	&command($line);
	next;
    }

    if (($line =~ /\<\!\-\-\#.*\-\-\>/o)
	&& ($OLDFORMATONLY ne "yes"))
    {
	&hina0($line);
    }
    elsif (($line =~ /\<a\s.*\>/o)
	   && ($OLDFORMATONLY ne "yes"))
    {
	&hina0($line);
    }
    else
    {
	print $line;
    }
}

&DoKillParent();

exit 0;


sub command
{
    local($_) = shift;

    local(@cmd) = split;
    local($opcode) = "\L$cmd[0]\E";

    print "line: $_" if ($DEBUG);
    print "Opcode: $opcode\n" if ($DEBUG);

    if (!$opcode)
    {
	return;
    }
    elsif ($opcode eq "end")
    {
	print "end:\n" if ($DEBUG);

	print "HINA/2.0\n";
	print "User-Agent: $AGENT\n";
	print "\n";

	foreach $tag (keys(%CACHE_URL))
	{
	    %di = &getcache($tag);
	    &diout(%di);
	}

	&DoKillParent();
	exit(0);
    }
    elsif ($opcode eq "connect")
    {
	print "connect: start\n" if ($DEBUG);
	%opt = ();
	$opt{'PROXY'} = $PROXYSERVER;
	$HANDLE = $cmd[1];
	$opt{'HANDLE'} = $HANDLE;
	$result = &httpconnect($url, *dinfo, *opt);
	print "connect: $result\n" if ($DEBUG);
    }
    elsif ($opcode eq "close")
    {
	print "close: $HANDLE\n" if ($DEBUG);
	close($HANDLE) if (! eof($HANDLE));
    }
    elsif ($opcode eq "getdi")
    {
	print "getdi:\n" if ($DEBUG);

	%opt = ();
	$opt{'PROXY'} = $PROXYSERVER;
	$opt{'HANDLE'} = $HANDLE;
	if ($PROXYSERVER eq "")
	{
	    $opt{'CONNECTION'} = "Keep-Alive";
	}
	$uri = $cmd[1];
	$file = "/tmp/hinaget.$$";
	$url = $HANDLE;
	$url =~ s/\/$//o;
	$url .= $uri;

	%di = ();
	$result = &httpcom($url, $file, *di, *opt);

	&libhina'searchkey($file, "", *di); #'
	unlink($file) if (-f $file);

	$tag = &url2tag($url);

	if (($di{'RESULTCODE'} != 0) && (defined($CACHE_TIME{$tag})))
	{
	    %di = &getcache($tag);
	    $di{'METHOD'} = "CACHE";
	}

	if ((defined($odi{'LAST-MODIFIED'})
	     && ($odi{'LAST-MODIFIED'} > 0))
	    && ($odi{'METHOD'} !~ /400/o))
	{
	    $di{'LAST-MODIFIED-INTERVAL'} =
		$di{'LAST-MODIFIED'} - $odi{'LAST-MODIFIED'};
	}
	else
	{
	    $di{'LAST-MODIFIED-INTERVAL'} = 0;
	}

	if ((! defined($CACHE_TIME{$tag})) || ($CACHE_TIME{$tag} == 0))
	{
	    &setcache($tag, %di);
	}
    }
    else
    {
	print "$opcode: undefined command.\n";
	&DoKillParent();
	exit(1);
    }
}

sub hina1
{
    local($body) = shift if ($#_ >= 0);
    local($url) = "";
    $url = shift if ($#_ >= 0);

    local($key) = "";
    $key = shift if ($#_ >= 0);

    local($authorization) = "";
    $authorization = shift if ($#_ >= 0);
    $authorization = $PASSWD{$authorization};

    local(%di) = ();
    local(%odi) = ();

    local($tag);
    local($server, $portno, $protocol);
    local($wwwserver, $userfile);
    local(%idx);

    print "body: $body\n" if ($DEBUG);

    $di{'RESULTCODE'} = -103;

    $url =~ s%\#.*%%o;
    $remotefile = $url;
    $remotefile =~ s%^\w+://%%o;
    $remotefile =~ s%^/%%o;
    $remotefile =~ s%/.*%%o;
    print "RemoteFile:[$remotefile]\n" if ($DEBUG);
    if (-f $remotefile)
    {
	$url =~ s%^[^/]+/([^\~/])%$1%o;
    }

    $tag = &url2tag($url);

    if ($url =~ m%^[^/]%o)
    {
	$url = "http://".$tag;
    }
    print "URL:[$url]\n" if ($DEBUG);
    $di{'URL'} = $url;

    $di{'HINAS'} = "";

    if ($tag eq "")
    {
	&output($body, %di);
	return(1);
    }

    ($wwwserver, $userfile) = &resolvurl($url);
    ($server, $portno, $protocol) = &resolvserver($wwwserver);

    print "From:[$server]\n" if ($DEBUG);
    print "MethodOpt:[$HINA_METHOD]\n" if ($DEBUG);
    print "Authorization:[$authorization]\n" if ($DEBUG);

    print "URL:[$di{'URL'}]\n" if ($DEBUG);
    
    %di = &hina11($di{'URL'});
    
    $di{'HOP'} += 1;
    
    &result($body, %di);
    
    return 1;
}

sub DoTerminateParent
{
    print STDERR "hina-$HINA_VERSION: caught signal.\n";
    &DoKillParent();

    return 1;
}

sub DoKillParent
{
    if (-f $TMPFILE)
    {
	unlink($TMPFILE) || print STDERR "$TMPFILE: $!\n";
    }

    unlink("hina.lock") || print STDERR "hina.lock: $!\n";

    exit 0;
}

sub DoKillChild
{
    print STDERR "hina-$HINA_VERSION: internal error on ALRM.\n"
	if ($$ == $PARENT);

    exit 2;
}

sub hina2
{
    local($url) = shift;
    $url = "http://".$url if (! ($url =~ m%^\w+://%o));

    local($remfile) = "";
    $remfile = shift if ($#_ >= 0);

    local($wwwserver, $userfile) = &resolvurl($url);
    local($server, $portno, $protocol) = &resolvserver($wwwserver);
    local($tmpfile) = "/tmp/hina.$$";
    local($_);
    local($msince);
    local($line);
    local($ntime);
    local(%cdi, %odi);
    local(%opt) = ();

    
    if (($server eq $MYSERVER) || ($protocol eq "file"))
    {
	$url = "";
	$userfile = &expandfilename($userfile) if ($protocol ne "file");
	$remfile = $userfile;
	print "Get Info from file://$remfile\n" if ($DEBUG);
    }
    else
    {
	$url = $wwwserver.$userfile;
	
	if (-f $remfile)
	{
	    local($dev, $ino, $fmode, $nlink, $uid, $gid, $rdev,
		  $size, $atime, $mtime, $ctime,
		  $blksize, $blocks) = stat($remfile);
	    $opt{'IF-MODIFIED-SINCE'} = &gmtimestr($mtime);
	}
	
	$opt{'REFERER'} = $REFERER if (defined($REFERER));
	$opt{'USER-AGENT'} = $AGENT;
	$opt{'AUTHORIZATION'} = $PASSWD{$HINA_AUTHORIZATION}
	    if ($HINA_AUTHORIZATION ne "");
	
	if ($protocol eq "dirp")
	{
	    &getcontentoverdirp($url, $tmpfile, *di, *opt, $PROXYSERVER);
	}
	else
	{
	    &getcontentoverhttp($url, $tmpfile, *di, *opt, $PROXYSERVER);
	}
	
	if ($remfile ne "")
	{
	    open(TMPFILE, "$tmpfile");
	    
	    if (! eof(TMPFILE))
	    {
		open(REMFILE, "> $remfile")
		    || print STDERR "$remofile: $!\n";
		print REMFILE "$protocol\n";

		while ($line = <TMPFILE>)
		{
		    &jcode'convert(*line, "euc"); #'
		    $line =~ tr/\015\012//d;
		    last if ($line eq "");
		}

		while ($line = <TMPFILE>)
		{
		    &jcode'convert(*line, "euc"); #'
		    $line =~ tr/\015\012//d;
		    print REMFILE "$line\n";
		}
		close(REMFILE);
	    }
	    close(TMPFILE);
	}
	else
	{
	    $remfile = $tmpfile;
	}
    }

    print "$remfile\n" if ($DEBUG);
    open(REMFILE, "$remfile") ||
	die $!.' ['.$REMFILE.']';

    $remfiletype = "hina.txt";

    while ($line = <REMFILE>)
    {
	$line =~ tr/\015\012//d;
	last if ($line eq "");
	if ($line =~ /^HINA\/[\d\.]+/io)
	{
	    $remfiletype = "hina.di";
	    last;
	}
    }
    close(REMFILE);

    open(REMFILE, "$remfile") ||
	die $!.' ['.$REMFILE.']';

    while (! eof(REMFILE))
    {
	$ntime = time() + ((12 * 60) + 0) * 60; # after 12 hour

	if ($remfiletype eq "hina.di")
	{
	    %cdi = &readdi(*REMFILE);
	}
	elsif ($remfiletype eq "hina.txt")
	{
	    $line = <REMFILE>;
	    $line =~ tr/\015\012//d;

	    %cdi = ();
	    if ($line =~ /(http\:\/\/[^\"]+)/o)
	    {
		$cdi{'URL'} = $1;
		$cdi{'SERVER'} = "CERN-like" if ($line =~ /CERN/io);
		$cdi{'LAST-MODIFIED'} = &anltime($line);
		print "lastmod: $cdi{'LAST-MODIFIED'}\n" if ($DEBUG);
		next if ($cdi{'LAST-MODIFIED'} == 0);
		$cdi{'LAST-MODIFIED-DETECTED'} = time();
	    }
	}

	$cdi{'HINAS'} = $HINA_S{$remfile};
	$cdi{'EXPIRE'} = time() + $EXPIRE if ($cdi{'EXPIRE'} == 0);
	
	if ($cdi{'URL'} ne "")
	{
	    %odi = &getcache($cdi{'URL'});
	    print sprintf("time[%09ld]:get[%09ld]:cache[%09ld]\n",
			  $ntime,
			  $cdi{'LAST-MODIFIED'}, $odi{'LAST-MODIFIED'})
		if ($DEBUG);

	    next if ($cdi{'LAST-MODIFIED'} > $ntime);
	    next if ($cdi{'METHOD'} =~ /400/o);
	    next if ($cdi{'LAST-MODIFIED'} < $odi{'LAST-MODIFIED'});
	    if (($cdi{'LAST-MODIFIED'} >= $odi{'LAST-MODIFIED'})
		&& (($cdi{'METHOD'} =~ /FILE/io)
		    || ($odi{'METHOD'} !~ /FILE/io))
		&& (($cdi{'LAST-MODIFIED-DETECTED'}
		     > $odi{'LAST-MODIFIED-DETECTED'})
		    || (! $odi{'LAST-MODIFIED-DETECTED'})))
	    {
		&setcache($cdi{'URL'}, %cdi);
	    }
	}
    }
    close(REMFILE);
    
    unlink($tmpfile) if (-f $tmpfile);

    return 1;
}

sub result
{
    local($body, %di) = @_;
    local($monstr, $mdaystr, $hourstr, $minstr) = ("", "", "", "");

    local($tag) = &url2tag($di{'URL'});

    if ($CACHE_TIME{$tag} == 0)
    {
	&setcache($tag, %di);
    }

    &output($body, %di);

    $CACHE_OUT{$tag} = 1;

    return 1;
}

sub output
{
    local($body, %di) = @_;
    local($mode) = $di{'METHOD'};
    local($comment) = "";
    local($modtime) = "";
    local($modlabel) = "";
    local($cernstr) = $NOTCERNMARK;
    local($ccyystr, $yystr, $monstr, $mdaystr,
	  $hourstr, $minstr, $secstr) =
	      ("????", "??", "??", "??", "??", "??", "??");

    if ($di{'RESULTCODE'} == 404)
    {
	$modtime = "$NFOUND";
	$comment = "<!--HINA_NOT_FOUND-->";
    }
    elsif ($di{'RESULTCODE'} == -100)
    {
	$modtime = "$TIMEOUT";
	$comment = "<!--HINA_TIMEOUT-->";
    }
    elsif ($di{'RESULTCODE'} == -101)
    {
	$modtime = "$REMOUT";
	$comment = "<!--HINA_REMOTE_OUT-->";
    }
    elsif ($di{'RESULTCODE'} == -102)
    {
	$modtime = "$BUSY";
	$comment = "<!--HINA_BUSY-->";
    }
    elsif (($di{'RESULTCODE'} == -103)
	   || ($di{'RESULTCODE'} >= 500))
    {
	$modtime = "$UNKNOWN";
	$comment = "<!--HINA_UNKNOWN-->";
    }
    elsif ($di{'RESULTCODE'} == -104)
    {
	$modtime = "$INTERR";
	$comment = "<!--HINA_REMOUT-->";
    }

    if (($di{'LAST-MODIFIED'} > 0) && ($di{'RESULTCODE'} == 0))
    {
	local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday,
	 $isdst) = localtime($di{'LAST-MODIFIED'});
	$year += 1900;
	$mon++;

	$modlabel = $HINA_QUERY;
	$ccyystr = sprintf("%04d", $year);
	$yystr = sprintf("%02d", $year % 100);
	$monstr = sprintf("%02d", $mon);
	$mdaystr = sprintf("%02d", $mday);
	$hourstr = sprintf("%02d", $hour);
	$minstr = sprintf("%02d", $min);
	$secstr = sprintf("%02d", $sec);
	$modtime = "";
	$comment =
	    sprintf("<!--HINA_OK %04d/%02d/%02d %02d:%02d [%s]-->",
		    $year, $mon, $mday, $hour, $min, $di{'HOP'});

    }

    $_ = $di{'SERVER'};
    if ((/CERN/o) ||
	(/Microsoft\-Internet\-Information\-Server/o) ||
	(m%Netscape\-Communications\/1\.1$%o) ||
	(m%Netscape\-Commerce\/1\.1$%o) ||
	(/IBM\-ICS/o) ||
	(m%Netscape\-Enterprise\/3\.0%o) ||
	($HINA_HREF =~ /\?/o))
    {
	$cernstr = $CERNMARK;
	$modlabel = "";
	$comment .= "<!--HINA_CERN-->";
    }

    $HINA_URL = $HINA_HREF;
    if ($HINA_URL =~ /\#/o)
    {
	$HINA_URL =~ s/(\#.*)/$modlabel$1/;
    }
    elsif (($HINA_URL !~ /\?/o) && ($modlabel !~ /\?/o))
    {
	$HINA_URL .= $modlabel;
    }

    $HINA_LAST_MODIFIED =~ $di{'LAST-MODIFIED'};
    $HINA_TITLE = $di{'TITLE'} if ($HINA_TITLE eq "");
    $HINA_TITLE = $HINA_ATITLE
        if (($HINA_TITLE eq "TITLE UNKNOWN")
            || (($di{'LAST-MODIFIED'} == 0)
                && ($HINA_ATITLE ne "")));
    $HINA_KEYWORD = $di{'KEYWORD'} if ($HINA_KEYWORD eq "");
    $HINA_AUTHOR_NAME = $di{'AUTHOR-NAME'}
    if ($HINA_AUTHOR_NAME eq "");

    while ($body =~ /%i\{(\w+)\}/)
    {
	local($var) =$1;
	local($uvar) = $var;
	local($str);
	$uvar =~ s/(.*)/\U$1\E/o;
	local($cmdline) = "\$str=\$HINA_".$uvar.";";
	print "Eval   : $cmdline\n" if ($DEBUG);
	eval $cmdline;
	$body =~ s/%i\{$var\}/$str/g;
    }

    $mode =~ s/VIRTUAL//iog;
    $mode =~ s%\/%%og;
    $mode =~ s/^(.).*/$1/o;

    $body =~ s/%a/$modlabel/g;
    $body =~ s/%Y/$ccyystr/g;
    $body =~ s/%y/$yystr/g;
    $body =~ s/%m/$monstr/g;
    $body =~ s/%d/$mdaystr/g;
    $body =~ s/%R/%H:%M/g;
    $body =~ s/%H/$hourstr/g;
    $body =~ s/%M/$minstr/g;

    $body =~ s/%v/$HINA_VERSION/g;
    $body =~ s/%t/$HINA_TITLE/g;
    $body =~ s/%A/$HINA_AUTHOR_NAME/g;
    $body =~ s/%u/$HINA_HREF/g;
    $body =~ s/%s/$mode/g;
    $body =~ s/%\?/$cernstr/g;
    $body =~ s/%l/$HINA_LAST_MODIFIED/g;

    local($symbol);
    local($authorizedurl) = $di{'AUTHORIZED-URL'};
    local($referer) = $REFERER;
    $authorizedurl =~ s/\%7E/\~/iog;
    $referer =~ s/\%7E/\~/iog;

    if (($authorizedurl eq $referer) &&
	($di{'METHOD'} =~ /REMOTE/io))
    {
	$symbol = "C";
    }
    elsif (defined($SYMBOL{$authorizedurl}))
    {
	$symbol = $SYMBOL{$authorizedurl};
    }
    elsif ($di{'HINAS'} ne "")
    {
	$symbol = $di{'HINAS'};
    }
    else
    {
	$symbol = $mode;
    }
    $body =~ s/%S/$symbol/g;

    if ($modtime eq "")
    {
	$body =~ s/[\{\}]//og;
    }
    else
    {
	$body =~ s/\{[^\}]*\}/$modtime/;
    }

    print "BEGIN----output\n" if ($DEBUG);
    if ($body ne "")
    {
	print "$comment";
	print "$body";
	print "\n" if ($FORCENEWLINE);
    }
    print "\nEND------output\n" if ($DEBUG);

    return 1;
}


sub resolvurl
{
    local($_) = shift;
    local($protocol) = "http://";
    local($server, $userfile);

    if (m%^(\w+://)%o)
    {
	s%^(\w+://)%%o;
	$protocol = $1;
    }

    if ($protocol eq "file://")
    {
	$server = $protocol;
	$userfile = $_;
    }
    else
    {
	m%^([^/]+)(\S*)$%;
	($server, $userfile)  = ($protocol.$1, $2);
    }
    
    return($server, $userfile);
}    

sub expandfilename
{
    local($_) = &fixurl(shift);
    
    local($user) = "";
    if (m:(\~|\%7E)([^/]+):io)
    {
	$user = $2;

	local($name, $passwd, $uid, $gid, $quota, $comment,
	      $gcos, $dir, $shell) =
		  getpwnam($user);
	
      s:/(\~|\%7E)[^/]+:$dir/$USERDIR:i;
    }
    else
    {
	$_ = $MYWWWDIR.$_;
    }

    s%/$%/index.html%o;

    print "Localfile: $_\n" if ($DEBUG);
    
    return($_);
}

sub hina0
{
    local($line) = shift;
    local($linea, $oldline);
    print "$line\n" if ($DEBUG);

    while($line ne "")
    {
	$oldline = $line;
	$line =~ /^([^\<\>]*)(.*)/o;
	($linea, $line) = ($1, $2);
	if ($linea eq "")
	{
	    $line =~ /^(\<\!\-\-.*\-\-\>)(.*)/o;
	    ($linea, $line) = ($1, $2);
	    if ($linea eq "")
	    {
		$line =~ /^(\<[^\>]*\>)(.*)/o;
		($linea, $line) = ($1, $2);
	    }
	}	    
	&hina01($linea);

	$line = "" if ($line eq $oldline);
    }
    print "\n";

    return 1;
}

sub hina01
{
    local($line) = shift;
    local($command, $option);
    local(@options);
    local($cmdline);

    ($HINA_VIRTUAL, $HINA_FILE, $HINA_KEY, $HINA_METHOD) =
	("", "", "", "");
    ($HINA_TITLE, $HINA_KEYWORD, $HINA_AUTHORIZATION) = ("", "", "");
    ($HINA_ATITLE, $HINA_AUTHOR_NAME) = ("", "");
    undef($HINA_SYMBOL) if (defined($HINA_SYMBOL));

    print "line: $line\n" if ($DEBUG);

    if ($line =~ /\<a\shref=\"http\:\/\/.*\>/io)
    {
	$line =~ s/\<a/\<\!\-\-\#hina_anchor/io;
	$line =~ s/\>$/\-\-\>/o;
    }
    
    if ($line =~ /\<\!\-\-\#(\S+) *(.*) *\-\-\>/o)
    {
	$command = "\U$1\E";
	$option = $2;

	print "Command: $command\n" if ($DEBUG);
	print "Option : $option\n" if ($DEBUG);
    
	$option =~ s/\\\"/\&\#34\;/og;
	@options = ($option =~ /(\S+=\"[^\"]*\")/og);
    
	$i = 0;
	while ($i <= $#options)
	{
	    local($foo, $bar) = $options[$i] =~ /([^=]+)(=.*)/og;
	    $foo =~ s/(\w*)/\U$1\E/o;
	    $bar =~ s/\&\#34\;/\\\"/og;
	    $bar =~ s/\%7E/\~/iog;
	    $bar =~ s/([^\\])\@/$1\\\@/og;
	    $cmdline = "\$HINA_".$foo.$bar.";";
	    if ($foo eq "VERSION")
	    {
		print "Ignore : $cmdline\n" if ($DEBUG);
	    }
	    else
	    {
		print "Eval   : $cmdline\n" if ($DEBUG);
		eval $cmdline;
	    }
	    
	    if (($command eq HINA_REMOTE) && ($foo eq "VIRTUAL"))
	    {
		if ($HINA_FILE eq "")
		{
		    $HINA_FILE = $HINA_VIRTUAL;
		    $HINA_FILE =~ s%http://%%o;
		    $HINA_FILE =~ s%/.*%%o;
		}
	    }
	    
	    $i++;
	}
	
	if ($command eq HINA_REMOTE)
	{
	    print "Href   : $HINA_HREF\n" if ($DEBUG);
	    print "Virtual: $HINA_VIRTUAL\n" if ($DEBUG);
	    print "File   : $HINA_FILE\n" if ($DEBUG);
	    
	    if ($HINA_HREF eq "")
	    {
		$HINA_HREF = $HINA_VIRTUAL;
		$HINA_HREF =~ s%[^\/]*$%%o;
	    }
	    
	    if ($HINA_VIRTUAL eq "")
	    {
		if ($HINA_HREF =~ m%^http://%io)
		{
		    $HINA_VIRTUAL = $HINA_HREF;
		}
	    }
	    
	    local($symbol);
	    undef($symbol);
	    $symbol = $HINA_S{$HINA_FILE} if (defined($HINA_S{$HINA_FILE}));
	    $symbol = $HINA_SYMBOL if (defined($HINA_SYMBOL));
	    print "Symbol : $symbol\n" if ($DEBUG);
	    if (defined($symbol))
	    {
		local($url);
		$url = $HINA_HREF;
		$url =~ s/\%7E/\~/iog;
		$SYMBOL{$url} = $symbol;
		$url = $HINA_VIRTUAL;
		$url =~ s/\%7E/\~/iog;
		$SYMBOL{$url} = $symbol;
	    }
	    
	    return 1;
	}
	elsif ($command eq HINA_ANCHOR)
	{
	    print "HREF   : $HINA_HREF\n" if ($DEBUG);
	    print "Virtual: $HINA_VIRTUAL\n" if ($DEBUG);
	    print "File   : $HINA_FILE\n" if ($DEBUG);
	    print "Key    : $HINA_KEY\n" if ($DEBUG);
	    print "Method : $HINA_METHOD\n" if ($DEBUG);
	    print "Query  : $HINA_QUERY\n" if ($DEBUG);
	    print "Auth.  : $HINA_AUTHORIZATION\n" if ($DEBUG);
	    print "Title  : $HINA_TITLE\n" if ($DEBUG);
	    
	    if (($HINA_VIRTUAL eq "") && ($HINA_FILE eq ""))
	    {
		if ($HINA_HREF =~ m%^http://%io)
		{
		    $HINA_VIRTUAL = $HINA_HREF;
		}
	    }
	    
	    if ($HINA_VIRTUAL eq "")
	    {
		print "BEGIN----output\n" if ($DEBUG);
		print "$line";
		print "\nEND------output\n" if ($DEBUG);
	    }
	    else
	    {
		local($format) = "<a href=\"$HINA_HREF%a\">";
		&hina1($format, $HINA_VIRTUAL, $HINA_KEY,
		       $HINA_AUTHORIZATION);
	    }
	    
	    return(1);
	}
	elsif ($command eq FLASTMOD)
	{
	    $HINA_HREF = $HINA_VIRTUAL if ($HINA_HREF eq "");
	    $HINA_VIRTUAL = $HINA_HREF if ($HINA_VIRTUAL eq "");
	    if ($DEBUG)
	    {
		print "Href   : $HINA_HREF\n";
		print "Virtual: $HINA_VIRTUAL\n";
		print "File   : $HINA_FILE\n";
		print "Key    : $HINA_KEY\n";
		print "Title  : $HINA_TITLE\n";
		print "KeyWord: $HINA_KEYWORD\n";
		print "Method : $HINA_METHOD\n";
		print "TimeFmt: $HINA_TIMEFMT\n";
		print "Auth.  : $HINA_AUTHORIZATION\n";
		print "Title  : $HINA_TITLE\n" if ($DEBUG);
	    }

	    if ($HINA_FILE ne "")
	    {
		print "BEGIN----output\n" if ($DEBUG);
		print "$line";
		print "\nEND------output\n" if ($DEBUG);
	    }
	    else
	    {
		&hina1($HINA_TIMEFMT, $HINA_VIRTUAL, $HINA_KEY,
		       $HINA_AUTHORIZATION);
	    }
	    
	    return(1);
	}
	elsif ($command eq ECHO)
	{
	    if ($HINA_VAR =~ /^HINA_/o)
	    {
		$cmdline = "\$line=\$".$HINA_VAR.";";
		print "Eval   : $cmdline\n" if ($DEBUG);
		eval $cmdline;
	    }
	}	    
    }

    print "BEGIN----output\n" if ($DEBUG);
    print "$line";
    print "END------output\n" if ($DEBUG);

    return 1;
}

sub hina11
{
    local($tag) = &url2tag(shift);

    local(%cdi);

    %cdi = &getcache($tag);
    &showdi(%cdi) if ($DEBUG);

    return(%cdi);
}

sub showdi
{
    local(%di) = @_;

    local($key, $val);

    while (($key, $val) = each(%di))
    {
	printf("DI{%s} = [%s]\n", $key, $val);
    }

    return 1;
}

sub diout
{
    local(%di) = @_;

    if ($di{'URL'} =~ m%^\w+://%o)
    {
	print "URL: ".&fixurl($di{'URL'})."\n";
	if ($di{'TITLE'} eq "")
	{
	    if ($HINA_ATITLE ne "")
	    {
		$di{'TITLE'} = $HINA_ATITLE;
	    }
	    else
	    {
		$di{'TITLE'} = "TITLE UNKNOWN";
	    }
	}

	printf("Date: %s\n", &gmtimestr(time()));
	printf("Title: %s\n", $di{'TITLE'});
	$di{'AUTHOR-NAME'} = "AUTHOR UNKNOWN"
	    if ($di{'AUTHOR-NAME'} eq "");
	printf("Author-Name: %s\n", $di{'AUTHOR-NAME'});
	printf("Keyword: %s\n", $di{'KEYWORD'});
	print "Content-Type: $di{'CONTENT-TYPE'}\n"
	    if ($di{'CONTENT-TYPE'} ne "");
	printf("Expire: %s\n", &gmtimestr($di{'EXPIRE'}))
	    if ($di{'EXPIRE'} > 0);
	printf("Last-Modified: %s\n", &gmtimestr($di{'LAST-MODIFIED'}))
	    if ($di{'LAST-MODIFIED'} > 0);
	printf("Last-Modified-Detected: %s\n",
	       &gmtimestr($di{'LAST-MODIFIED-DETECTED'}))
	    if ($di{'LAST-MODIFIED-DETECTED'} > 0);
	printf("Last-Modified-Interval: %d\n",
	       $di{'LAST-MODIFIED-INTERVAL'})
	    if ($di{'LAST-MODIFIED-INTERVAL'} > 0);
	print "Server: $di{'SERVER'}\n" if ($di{'SERVER'} ne "");
	print "Authorized: $di{'AUTHORIZED'}\n"
	    if ($di{'AUTHORIZED'} ne "");
	print "Authorized-url: ".&fixurl($di{'AUTHORIZED-URL'})."\n"
	    if ($di{'AUTHORIZED-URL'} ne "");
	print "Image-Width: $di{'IMAGE-WIDTH'}\n"
	    if ($di{'IMAGE-WIDTH'} ne "");
	print "Image-Height: $di{'IMAGE-HEIGHT'}\n"
	    if ($di{'IMAGE-HEIGHT'} ne "");
	print "Method: $di{'METHOD'}\n" if ($di{'METHOD'} ne "");
	print "\n";
    }
    return 1;
}

sub setcache
{
    local($tag, %di) = @_;

    print "SetCacheUrl:[$di{'URL'}]\-\>$tag\n" if ($DEBUG);
    $tag = &url2tag($tag);

    if ($di{'URL'} =~ m%^\w+://%o)
    {
	print "SetCache:[$tag]\n" if ($DEBUG);
	&showdi(%di) if ($DEBUG);
	$CACHE_URL{$tag} = &fixurl($di{'URL'});
	$CACHE_OUT{$tag} = 0 if (! defined($CACHE_OUT{$tag}));
	$CACHE_TITLE{$tag} = $di{'TITLE'};
	$CACHE_AUTHORNAME{$tag} = $di{'AUTHOR-NAME'};
	$CACHE_TIME{$tag} = $di{'LAST-MODIFIED'};
	$CACHE_INTERVAL{$tag} = $di{'LAST-MODIFIED-INTERVAL'};
	$CACHE_DETECTED{$tag} = $di{'LAST-MODIFIED-DETECTED'};
	$CACHE_DATE{$tag} = $di{'DATE'};
	$CACHE_CONTENTTYPE{$tag} = $di{'CONTENT-TYPE'};
	$CACHE_EXPIRE{$tag} = $di{'EXPIRE'};
	$CACHE_KEYWORD{$tag} = $di{'KEYWORD'};
	$CACHE_SERVER{$tag} = $di{'SERVER'};
	$CACHE_AUTHORIZED{$tag} = $di{'AUTHORIZED'};
	$CACHE_AUTHORIZEDURL{$tag} = $di{'AUTHORIZED-URL'};
	$CACHE_METHOD{$tag} = $di{'METHOD'};
	$CACHE_HOP{$tag} = $di{'HOP'};
	$CACHE_HINAS{$tag} = $di{'HINAS'};
    }

    return 1;
}

sub getcache
{
    local($tag) = shift;
    local(%di) = (URL, $tag, 'LAST-MODIFIED', 0, METHOD, "R",
		  RESULTCODE, -101);

    $tag = &url2tag($tag);

    if ($CACHE_TIME{$tag} > 0)
    {
	print "GetCache:[$tag]\n" if ($DEBUG);

	$di{'URL'} = $CACHE_URL{$tag};
	$di{'TITLE'} =$CACHE_TITLE{$tag};
	$di{'AUTHOR-NAME'} =$CACHE_AUTHORNAME{$tag};
	$di{'LAST-MODIFIED'} = $CACHE_TIME{$tag};
	$di{'LAST-MODIFIED-INTERVAL'} = $CACHE_INTERVAL{$tag};
	$di{'LAST-MODIFIED-DETECTED'} = $CACHE_DETECTED{$tag};
	$di{'DATE'} = $CACHE_DATE{$tag};
	$di{'EXPIRE'} = $CACHE_EXPIRE{$tag};
	$di{'CONTENT-TYPE'} = $CACHE_CONTENTTYPE{$tag};
	$di{'KEYWORD'} =$CACHE_KEYWORD{$tag};
	$di{'SERVER'} = $CACHE_SERVER{$tag};
	$di{'AUTHORIZED'} = $CACHE_AUTHORIZED{$tag};
	$di{'AUTHORIZED-URL'} = $CACHE_AUTHORIZEDURL{$tag};
	$di{'METHOD'} = $CACHE_METHOD{$tag};
	$di{'HINAS'} = $CACHE_HINAS{$tag};
	$di{'HOP'} = $CACHE_HOP{$tag};
	$di{'OUT'} = $CACHE_OUT{$tag};
	$di{'RESULTCODE'} = 0;

	$di{'RESULTCODE'} = 404 if ($di{'METHOD'} =~ m:404:io);
    }
    return (%di);
}

sub url2tag
{
    local($tag) = shift;

    $tag =~ s%^\w+://%%og;
    $tag =~ s%^/%%og;
    $tag =~ s/\#.*//og;
    $tag = &fixurl($tag);

    return($tag);
}

sub loadauthfile
{
    local($authfile) = shift;
    local(*loadauthfilepasswd) = shift;

    if (-e $authfile)
    {
	local($label, $passwd);

	open(AUTHFILE, "$authfile") || die("$authfile: $!");

	while (<AUTHFILE>)
	{
	    tr/\015\012//d;
	    ($label, $passwd) = split(":");
	    $loadauthfilepasswd{$label} = $passwd;
	    print "\$passwd{$label} = $passwd\n" if ($DEBUG);
	}
	
	close(AUTHFILE);
    }
}

sub msg
{
    local($msg) = shift;
    local($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
    $year += 1900 if ($year < 100);
    $year += 100 if ($year < 1970);

    local($str) =
	sprintf("%04d/%02d/%02d %02d:%02d:%02d [%d] %s",
		$year, $mon + 1, $mday, $hour, $min, $sec, $$, $msg);

    print STDERR $str if ($DEBUG);

    if ($LOGFILE ne "")
    {
	local($select) = select(LOGFILE);
	$| = 1;
	print $str;
	select($select);
    }
}

1;
